/*
	about.c
	Displays the application's help (for the moment it's just an About
	dialog box, and besides, this program is not difficult to use, or
	is it?).

	mmore - A file/stream viewer for Motif/X
	Copyright (C) 2005   Matthew Holder (sixxgate@hotmail.com)

	derived from:
	mas - A file/stream viewer for X
	Copyright (C) 1998   Roberto Machorro (rmach@bigfoot.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include "about.h"

#define ABOUT_TEXT "MMore version %1.2f\n\n\
File/Stream viewer for Motif.\n\n\
MMore comes with ABSOLUTELY NO WARRANTY.\n\
This is free software, and you are welcome\n\
to redistribute it under certain conditions;\n\
please read LICENSE file for details.\n\n\
Newest version and info is available at:\n\
http://matt.sixxgate.com/\n\n\
Copyright (C)2005\n\n\
Matthew Holder"
     
void help(Widget w, XtPointer client_data, XmAnyCallbackStruct *call)
{
	XmString message;
	Arg args[10]; Cardinal n;
	Widget dlg, txtbox, divider, okbtn;
	
	XmTextPosition curpos;
	char title[60]; char about[344];

	n = 0;
	sprintf(title, "About MMore", APP_VERSION);
	XtSetArg(args[n], XmNtitle, title); n++;
	XtSetArg(args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL);n++;
	XtSetArg(args[n], XmNmarginHeight, 7); n++;
	XtSetArg(args[n], XmNmarginWidth, 7); n++;
	XtSetArg(args[n], XmNverticalSpacing, 3); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 3); n++;
	dlg = XmCreateFormDialog((Widget)client_data, "AboutDialog", args, n);

	n = 0;
	sprintf(about, ABOUT_TEXT, APP_VERSION);
	XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
	XtSetArg(args[n], XmNeditable, FALSE); n++;
	XtSetArg(args[n], XmNrows, 15); n++;
	XtSetArg(args[n], XmNcolumns, 45); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	txtbox = XmCreateText(dlg, "TextBox", args, n);
	curpos = XmTextGetLastPosition(txtbox);
	XmTextInsert(txtbox, curpos, about);

	n = 0;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNtopWidget, txtbox); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	divider = XmCreateSeparator(dlg, "Divider", args, n);

	n = 0;
	message = XmStringCreateSimple("OK");
	XtSetArg(args[n], XmNlabelString, message); n++;
	XtSetArg(args[n], XmNshowAsDefault, True); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNtopWidget, divider); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	okbtn = XmCreatePushButton(dlg, "OKBTN", args, n);
	XmStringFree(message);

	XtManageChild(okbtn);
	XtManageChild(divider);
	XtManageChild(txtbox);
	XtManageChild(dlg);
}
