/*
	errdlg.c
	Creates a simple dialog wich displays an error message.

	mmore - A file/stream viewer for Motif/X
	Copyright (C) 2005   Matthew Holder (sixxgate@hotmail.com)

	derived from:
	mas - A file/stream viewer for X
	Copyright (C) 1998   Roberto Machorro (rmach@bigfoot.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include "errdlg.h"

void errorDialog(Widget parent, char *msg)
{
	XmString message;
	Arg args[5]; Cardinal n;
	Widget dlg, msglabel, divider, okbtn;

	n = 0;
	XtSetArg(args[n], XmNtitle, "Oops!"); n++;
	XtSetArg(args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
	XtSetArg(args[n], XmNmarginHeight, 7); n++;
	XtSetArg(args[n], XmNmarginWidth, 7); n++;
	XtSetArg(args[n], XmNverticalSpacing, 3); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 3); n++;
	dlg = XmCreateFormDialog(parent, "ErrorDialog", args, n);

	n = 0;
	message = XmStringCreateSimple(msg);
	XtSetArg(args[n], XmNlabelString, message); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	msglabel = XmCreateLabel(dlg, "Message", args, n);
	XmStringFree(message);

	n = 0;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNtopWidget, msglabel); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	divider = XmCreateSeparator(dlg, "Divider", args, n);

	n = 0;
	message = XmStringCreateSimple("OK");
	XtSetArg(args[n], XmNlabelString, message); n++;
	XtSetArg(args[n], XmNshowAsDefault, True); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNtopWidget, divider); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	okbtn = XmCreatePushButton(dlg, "OKBTN", args, n);
	XmStringFree(message);

	XtManageChild(okbtn);
	XtManageChild(divider);
	XtManageChild(msglabel);
	XtManageChild(dlg);
}
